<?php

define("LONGSIDE", 1600);
define("JPEGQUALITY", 90);
define("BUILT", "2008-08-07");
define("VERSION", "0.9");

//das Programm selbst nicht verkleinern ;)
unset($_SERVER["argv"][0]);

if(count($_SERVER["argv"]) == 0) {
	echo "Image-Resizer ".VERSION."\n";
	echo BUILT." by chris (at) hobbyelektronik.org\n\n";
	echo "Zieh' einfach eine Bilddatei auf mich!";
	sleep(2);
	exit();
}

//Fr die Summe
$allinsize = 0;
$alloutsize = 0;

//Alle Dateien verarbeiten...
foreach($_SERVER["argv"] as $infile) {
	$outfile = preg_replace('/^(.*)(\.[A-z]*)$/', '\1_sm\2', $infile);
	$insize = filesize($infile);
	
	echo "Verkleinere $infile -> $outfile...\n";
	if(resizepic($infile, $outfile, LONGSIDE) == true) {
		$outsize = filesize($outfile);
		$allinsize += $insize;
		$alloutsize += $outsize;
		echo "Datei verkleinert! ".NiceFilesize($insize)." -> ".NiceFilesize($outsize)." (".round((1-$outsize/$insize)*100, 2)."% gespart)\n\n";
	}
	
}

echo "Alle Dateien verarbeitet!\n";
echo "Alles in Allem: ".NiceFilesize($allinsize)." -> ".NiceFilesize($alloutsize)." (".round((1-$alloutsize/$allinsize)*100, 2)."% gespart)\n\n";
sleep(2);

//Schne Dateigren ermitteln
function NiceFilesize($fsize) {
	$fsnames = Array("B", "KiB", "MiB", "GiB", "TiB", "PiB", "EiB", "ZiB", "YiB", "NiB", "DiB");
	$fsexp = 0;
	if($fsize < 1024) return $fsize."B";
	do {
		$fsexp++;
	} while(($fsize /= 1024) > 1024);
	return round($fsize, 2).$fsnames[$fsexp];
}

//Das eigentliche Herz des Scripts
function resizepic($infile, $outfile, $longside) {
	//Infos des Bildes Laden
	$infos = @getimagesize($infile);
	
	if($infos == null) {
		echo "Konnte Datei nicht verarbeiten!\n";
		return false;
	}
	
	//Bild laden:
	if($infos[2] == 1) { //gif
		$src_img = imagecreatefromgif($infile);
	} elseif($infos[2] == 2) { //jpeg
		$src_img = imagecreatefromjpeg($infile);
	} elseif($infos[2] == 3) { //png
		$src_img = imagecreatefrompng($infile);
	}
	
	$new_w = imagesx($src_img);
	$new_h = imagesy($src_img);
	
	if($new_w > $new_h) {
		if($new_w > $longside) {
			$new_h /= $new_w / $longside;
			$new_w = $longside;
		}
	} else {
		if($new_h > $longside) {
			$new_w /= $new_h / $longside;
			$new_h = $longside;
		}
	}
	
	$dst_img = imagecreatetruecolor($new_w, $new_h);
	
	imagecopyresampled($dst_img, $src_img, 0, 0, 0, 0, $new_w, $new_h, imagesx($src_img), imagesy($src_img));
	
	imagedestroy($src_img);
	if($infos[2] == 2) {
		if(@imagejpeg($dst_img, $outfile, JPEGQUALITY) == false) {
			echo "Datei konnte nicht geschrieben werden! Liegt sie auf einem schreibgeschuetzten Medium?\n";
			return false;
		} 
	} else {
		if(@imagepng($dst_img, $outfile) == false) {
			echo "Datei konnte nicht geschrieben werden! Liegt sie auf einem schreibgeschuetzten Medium?\n";
			return false;
		}
	}
	
	imagedestroy($dst_img);
	return true;
}
?>
